var U=1,$=60,j=3600,q=86400,W=604800,k=class n{constructor(e,t=1){this.rate=e;this.size=t;if(e<=0)throw"rate must be greater than 0";if(t<1)throw"size must be at least 1"}static parse(e){let r=/(?<rate>\d+)\s*\/\s*(?<unit>second|minute|hour|day|week)\s*(,\s*(?<size>\d+))?/gi.exec(e);if(!r)throw"unable to parse refill value "+e;let s=parseInt(r.groups.rate),o=n.unitToDenominator(r.groups.unit.toLowerCase()),a=parseInt(r.groups.size??"1");return new n(s/o,a)}static unitToDenominator(e){switch(e){case"second":return 1;case"minute":return 60;case"hour":return 3600;case"day":return 86400;case"week":return 604800;default:throw"unexpected unit"}}};var p=class{apply(e,t,r,s){let o=e.size-s,a=Math.floor(s),i=Math.max(t-s,0),c=i>0?Math.ceil(i/e.rate):0,d=`${e.size};w=${e.rate}`;return{allowed:r,limit:o,remaining:a,reset:c,policy:d}}};var x=class extends p{buckets=new Map;async consume(e,t,r=1){let s=Date.now(),o=this.buckets.get(e);o||(o={tokens:t.size,updated:s},this.buckets.set(e,o));let i=(s-o.updated)*t.rate/1e3;o.tokens=Math.min(t.size,o.tokens+i),o.updated=s;let c=o.tokens>=r;return c&&(o.tokens-=r),this.apply(t,r,c,o.tokens)}};import"redis";var w=class n extends p{constructor(t,r="bucket:",s="TokenBucket",o="consume"){super();this.redis=t;this.prefix=r;this.module=s;this.fname=o}async consume(t,r,s=1){let o=await this.redis.sendCommand(["TFCALL",`${this.module}.${this.fname}`,"0",this.prefix+t,r.size.toString(),r.rate.toString(),s.toString()]),a=!1,i=0;for(let c=0;c<o.length;c+=2){let d=o[c],g=o[c+1];switch(d){case"allowed":a=g===1;break;case"tokens":i=parseFloat(g);break}}return this.apply(r,s,a,i)}static async create(t,r="bucket:",s="TokenBucket",o="consume"){let a=`#!js name=${s} api_version=1.0
redis.registerFunction('${o}', (client, key, size, rate, count) => {
	const now = Date.now()

	let bucket = client.call('hgetall', key)
	if (bucket.updated) {
		const deltaMs = now - parseInt(bucket.updated)
		const deltaNo = deltaMs * rate / 1000

		bucket.tokens = Math.min(size, parseFloat(bucket.tokens) + deltaNo)
		bucket.updated = now
	} else {
		bucket = { tokens: size, updated: now }
	}

	const allowed = bucket.tokens >= count
	if (allowed) {
		bucket.tokens -= count
	}

	// calculate how many tokens, or fractions of a token, are needed for the bucket to be full
	const deltaNo = Math.max(size - bucket.tokens, 0)

	// calculate time until the bucket is full, based on refill rate
	const expire = deltaNo > 0 ? Math.ceil(deltaNo / rate) : 0

	client.call('hset', key, 'tokens', bucket.tokens.toString(), 'updated', bucket.updated.toString())
	client.call('expire', key, expire.toString())

	return {
		allowed,
		tokens: bucket.tokens,
	}
})`;return await t.sendCommand(["TFUNCTION","LOAD","REPLACE",a]),new n(t,r,s,o)}};var m=class{constructor(e,t){this.status=e,typeof t=="string"?this.body={message:t}:t?this.body=t:this.body={message:`Error: ${e}`}}toString(){return JSON.stringify(this.body)}};function l(n,e){throw(!!1||!1)&&(isNaN(n)||n<400||n>599)?new Error(`HTTP error status codes must be between 400 and 599 \u2014 ${n} is invalid`):new m(n,e)}var fe=new TextEncoder;var b=class{constructor(e,t,r){this.extractor=e;this.manager=t;this.bucket=r}handle=async e=>{let{event:t,resolve:r}=e,{locals:s}=t,o=await this.extractor.extract(t),a=await this.manager.validate(o);return s.api=new f(t,this.bucket,o,a),await r(t)}},f=class{constructor(e,t,r,s){this.event=e;this.bucket=t;this.key=r;this.info=s}_name="";_cost=1;_anon=!1;_has="";_any=[];_all=[];anonymous(){return this._anon=!0,this}name(e){return this._name=e,this}cost(e){return e<1&&l(500,"API cost must be at least 1"),this._cost=e,this}has(e){return this._has=e,this}any(e){return this._any=e,this}all(e){return this._all=e,this}async approve(e){let{key:t,info:r}=this;if(!this._anon&&!t&&l(401,"Missing API Key"),t&&!this.info&&l(403,"Invalid API Key"),r){if(r.expires&&r.expires.getTime()<Date.now()&&l(403,"API Key Expired"),this._has.length&&!r.permissions.includes(this._has)&&l(403,"Missing Permission: "+this._has),this._all.length&&!this._all.every(i=>r.permissions.includes(i))){let i=this._all.filter(c=>!r.permissions.includes(c)).join(", ");l(403,"Missing Permissions: "+i)}if(this._any.length&&!this._any.some(i=>r.permissions.includes(i))){let i=this._any.join(", ");l(403,"Missing any Permission: "+i)}}let o=(r?.user||this.event.getClientAddress())+":"+this._name,a=await this.bucket.consume(o,e,this._cost);return this.event.setHeaders({"RateLimit-Limit":a.limit.toString(),"RateLimit-Remaining":a.remaining.toString(),"RateLimit-Reset":a.reset.toString(),"RateLimit-Policy":a.policy}),a.allowed||l(429,"Too Many Requests"),a}};var v=class{constructor(e){this.options=e}async extract(e){let t=null,r=e.request.clone();return this.options.cookie&&(t=e.cookies.get(this.options.cookie)??null),this.options.httpHeader&&(t=r.headers.get(this.options.httpHeader)||t),this.options.searchParam&&(t=e.url.searchParams.get(this.options.searchParam)||t),this.options.custom&&(t=await this.options.custom(e,t)),t}};import{randomBytes as P,createHash as _}from"crypto";import F from"base-x";import N from"bad-words-next";import H from"bad-words-next/data/en.json";import M from"bad-words-next/data/es.json";import A from"bad-words-next/data/fr.json";import B from"bad-words-next/data/de.json";var O="0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ",R=F(O),u=new N;u.add(H);u.add(M);u.add(A);u.add(B);var I=class{constructor(e,t=32){this.storage=e;this.key_length=t}hashFromBytes(e){return _("sha256").update(e).digest("hex")}async generate(e){let t,r;do r=P(this.key_length),t=R.encode(r);while(u.check(t));let s=this.hashFromBytes(r);return await this.storage.put(s,e),{key:t,hash:s}}async validate(e){if(!e)return null;let t=R.decode(e),r=this.hashFromBytes(t),s=await this.storage.get(r);return s?{hash:r,...s}:null}async remove(e){return await this.storage.del(e)}async retrieve(e){return await this.storage.list(e)}};var h=class{constructor(e=1024,t=3600){this.maxSize=e;this.ttl=t*1e3}cache=new Map;ttl;get(e){let t=this.cache.get(e);if(t){let{ts:r,value:s}=t;if(r>Date.now()-this.ttl)return this.cache.delete(e),this.cache.set(e,t),s;this.cache.delete(e)}}set(e,t){return this.cache.size>=this.maxSize&&this.cache.delete(this.cache.keys().next().value),this.cache.set(e,{ts:Date.now(),value:t})}del(e){this.cache.delete(e)}};var S=class{constructor(e,t=1024,r=3600){this.store=e;this.cache=new h(t,r)}cache;async put(e,t){return this.cache.set(e,t),await this.store.put(e,t)}async get(e){return this.cache.get(e)??await this.store.get(e)}async del(e){this.cache.del(e),await this.store.del(e)}async list(e){return this.store.list(e)}};var z={toFirestore:n=>{let{hash:e,...t}=n;return t},fromFirestore:n=>{let e=n.data(),t=e.expires?e.expires.toDate():null;return{hash:n.id,...e,expires:t}}},D=class{constructor(e,t="api"){this.firestore=e;this.name=t;this.collection=this.firestore.collection(this.name).withConverter(z)}collection;async put(e,t){await this.collection.doc(e).set({hash:e,...t})}async get(e){return(await this.collection.doc(e).get()).data()||null}async del(e){await this.collection.doc(e).delete()}async list(e){return(await this.collection.where("user","==",e).get()).docs.map(r=>r.data())}};var E=class{keys=new Map;async put(e,t){this.keys.set(e,t)}async get(e){return this.keys.get(e)??null}async del(e){this.keys.delete(e)}async list(e){return Array.from(this.keys.entries()).filter(([r,s])=>s.user===e).map(([r,s])=>({hash:r,...s}))}};import{ErrorReply as L,SchemaFieldTypes as y}from"redis";var K=class n{constructor(e,t){this.redis=e;this.prefix=t}static async create(e,t="api:"){try{await e.ft.info(t+"index")}catch(r){if(r instanceof L&&r.message==="Unknown index name")await e.ft.create(t+"index",{user:y.TAG,permissions:y.TAG,expires:y.NUMERIC},{ON:"HASH",PREFIX:t});else throw r}return new n(e,t)}async put(e,t){await this.redis.hSet(this.prefix+e,{user:t.user,name:t.name,description:t.description,permissions:t.permissions.join(","),...t.expires?{expires:t.expires.getTime()/1e3}:{}})}async get(e){let t=await this.redis.hGetAll(this.prefix+e);return t.name===null?null:{user:t.user,name:t.name,description:t.description,permissions:t.permissions.split(","),expires:t.expires?new Date(parseFloat(t.expires)*1e3):null}}async del(e){await this.redis.del(this.prefix+e)}async list(e){let t=/[,.?<>{}[\]"':;!@#$%^&()\-+=~|/\\ ]/g,r=e.replace(t,"\\$&");return(await this.redis.ft.search(this.prefix+"index",`@user:{${r}}`)).documents.map(a=>{let i=a.value;return{hash:a.id,user:i.user,name:i.name,description:i.description,permissions:i.permissions.split(","),expires:i.expires?new Date(parseFloat(i.expires)*1e3):null}})}};export{f as Api,q as DAY,D as FirestoreKeyStore,j as HOUR,b as Handler,E as InMemoryKeyStore,x as InMemoryTokenBucket,v as KeyExtractor,I as KeyManager,S as LruCacheKeyStore,$ as MINUTE,K as RedisKeyStore,w as RedisTokenBucket,k as Refill,U as SECOND,p as TokenBucket,W as WEEK};
